# rpmlib.h File Reference

In Memoriam: Steve Taylor <staylor@redhat.com> was here, now he's not. More...

`#include <popt.h>`
`#include <rpm/rpmio.h>`
`#include <rpm/header.h>`
`#include <rpm/rpmtag.h>`
`#include <rpm/rpmds.h>`
`#include <rpm/rpmpgp.h>`
Include dependency graph for rpmlib.h:

Go to the source code of this file.

## Functions
void | headerMergeLegacySigs (Header h, const Header sigh)
| Translate and merge legacy signature tags into header.
Header | headerRegenSigHeader (const Header h, int noArchiveSize)
| Regenerate signature header.
## Variables
struct rpmMacroContext_s * | rpmGlobalMacroContext
struct rpmMacroContext_s * | rpmCLIMacroContext
const char *const | RPMVERSION
const char *const | rpmNAME
const char *const | rpmEVR
const int | rpmFLAGS
## RPMRC
#define | RPM_MACHTABLE_COUNT 4
enum | rpm_machtable_e { RPM_MACHTABLE_INSTARCH = 0, RPM_MACHTABLE_INSTOS = 1, RPM_MACHTABLE_BUILDARCH = 2, RPM_MACHTABLE_BUILDOS = 3 }
| Build and install arch/os table identifiers. More...
int | rpmReadConfigFiles (const char *file, const char *target)
| Read macro configuration file(s) for a target.
void | rpmGetArchInfo (const char **name, int *num)
| Return current arch name and/or number.
void | rpmGetOsInfo (const char **name, int *num)
| Return current os name and/or number.
int | rpmMachineScore (int type, const char *name)
| Return arch/os score of a name.
int | rpmShowRC (FILE *fp)
| Display current rpmrc (and macro) configuration.
void | rpmSetTables (int archTable, int osTable)
void | rpmFreeRpmrc (void)
| Destroy rpmrc arch/os compatibility tables.
int | rpmVersionCompare (Header first, Header second)
| Compare headers to determine which header is "newer".
rpmRC | headerCheckPayloadFormat (Header h)
| Check for supported payload format in header.
rpmRC | headerCheck (rpmts ts, const void *uh, size_t uc, char **msg)
| Check header consistency, performing headerGetEntry() the hard way.
rpmRC | rpmReadHeader (rpmts ts, FD_t fd, Header *hdrp, char **msg)
| Return checked and loaded header.
rpmRC | rpmReadPackageFile (rpmts ts, FD_t fd, const char *fn, Header *hdrp)
| Return package header from file handle, verifying digests/signatures.
rpmRC | rpmInstallSourcePackage (rpmts ts, FD_t fd, char **specFilePtr, char **cookie)
| Install source package.
int | rpmvercmp (const char *a, const char *b)
| Segmented string compare for version or release strings.
void | rpmFreeFilesystems (void)
| Release storage used by file system usage cache.
int | rpmGetFilesystemList (const char ***listptr, unsigned int *num)
| Return (cached) file system mount points.
int | rpmGetFilesystemUsage (const char **fileList, rpm_loff_t *fssizes, unsigned int numFiles, rpm_loff_t **usagesPtr, int flags)
| Determine per-file system usage for a list of files.

## Detailed Description

In Memoriam: Steve Taylor <staylor@redhat.com> was here, now he's not.

Definition in file rpmlib.h.

## Define Documentation

#define RPM_MACHTABLE_COUNT 4

No. of arch/os tables.

Definition at line 68 of file rpmlib.h.

## Function Documentation

void rpmFreeFilesystems | ( | void |  | ) |

Release storage used by file system usage cache.

Referenced by main().

int rpmGetFilesystemList | ( | const char *** | listptr,
|  | unsigned int * | num |
| ) |  |  |

Return (cached) file system mount points.

Return values:

  | listptr | addess of file system names (or NULL)
  | num | address of number of file systems (or NULL)

Returns:
  0 on success, 1 on error

int rpmGetFilesystemUsage | ( | const char ** | fileList,
|  | rpm_loff_t * | fssizes,
|  | unsigned int | numFiles,
|  | rpm_loff_t ** | usagesPtr,
|  | int | flags |
| ) |  |  |

Determine per-file system usage for a list of files.

Parameters:

  | fileList | array of absolute file names
  | fssizes | array of file sizes
  | numFiles | number of files in list

Return values:

  | usagesPtr | address of per-file system usage array (or NULL)

Parameters:

  | flags | (unused)

Returns:
  0 on success, 1 on error

rpmRC rpmInstallSourcePackage | ( | rpmts | ts,
|  | FD_t | fd,
|  | char ** | specFilePtr,
|  | char ** | cookie |
| ) |  |  |

Install source package.

Parameters:

  | ts | transaction set
  | fd | file handle

Return values:

  | specFilePtr | address of spec file name (or NULL)
  | cookie | address of cookie pointer (or NULL)

Returns:
  rpmRC return code

int rpmvercmp | ( | const char * | a,
|  | const char * | b |
| ) |  |  |

Segmented string compare for version or release strings.

Parameters:

  | a | 1st string
  | b | 2nd string

Returns:
  +1 if a is "newer", 0 if equal, -1 if b is "newer"

int rpmVersionCompare | ( | Header | first,
|  | Header | second |
| ) |  |  |

Compare headers to determine which header is "newer".

Parameters:

  | first | 1st header
  | second | 2nd header

Returns:
  result of comparison

## Variable Documentation

struct rpmMacroContext_s* rpmCLIMacroContext

const char* const rpmEVR

Referenced by printVersion().

const int rpmFLAGS

struct rpmMacroContext_s* rpmGlobalMacroContext

const char* const rpmNAME

const char* const RPMVERSION